﻿const
  Nmax = 20000;
  Mmax = 100000 * 2;
  Kmax = 100000 * 2;

type
  mas1 = array[1..3] of integer;
  mas2 = array[1..Mmax] of mas1;
  mas1_n = array[1..Nmax] of integer;
  mas1_n_string = array[1..Nmax] of string;
  mas1_set = array of integer;
  mas2_set = array[1..Nmax] of mas1_set;

var
  n, m, k: integer;
  name: mas1_n_string;
  s, name1, name2: string;
  e: mas2;
  comp: mas1_n;
  sub_set: mas2_set;
  ans: int64;
  count: integer;
  i, j, v: integer;
  w, start, finish, comp_start, comp_finish, err: integer;
  f_in, f_out: text;


procedure sort(l, r: integer; var e: mas2);
// Быстрая сортировка ребер по весу  
var
  i, j, x1, m: integer;
  y1: mas1;
begin
  i := l;
  j := r;
  m := round((l + r) / 2);
  x1 := e[m][1];
  repeat
    while e[i][1] < x1 do inc(i);
    while e[j][1] > x1 do dec(j);
    if i <= j then
    begin
      y1 := e[i];
      e[i] := e[j];
      e[j] := y1;
      inc(i);
      dec(j);
    end;
  until i > j;
  if l < j then sort(l, j, e);
  if i < r then sort(i, r, e);
end;

function bin_search(var a: mas1_n_string; key: string): integer;
// Бинарный поиск названий городов в упорядоченном массиве
var
  left, right, middle: integer;
begin
  left := 0; right := n + 1;
  middle := (left + right) div 2;
  while (right > left + 1) do 
  begin
    middle := (left + right) div 2;
    if a[middle] > key then right := middle
    else left := middle;
  end;
  if (left >= 1) and (a[left] = key) then 
    bin_search := left
  else
    bin_search := -1;
end;

begin
  // Ввод данных
  assign(f_in, 'input.txt');
  assign(f_out, 'output.txt');
  reset(f_in);
  rewrite(f_out);
  readln(f_in, n);
  for i := 1 to n do
    readln(f_in, name[i]);
  readln(f_in, m);
  for i := 1 to m do
  begin
    readln(f_in, s);
    name1 := copy(s, 1, pos(' ', s) - 1);
    delete(s, 1, pos(' ', s));
    name2 := copy(s, 1, pos(' ', s) - 1);
    delete(s, 1, pos(' ', s));
    val(s, w, err);
    e[2 * i - 1][1] := w;
    e[2 * i - 1][2] := bin_search(name, name1);
    e[2 * i - 1][3] := bin_search(name, name2);
    e[2 * i][1] := w;
    e[2 * i][2] := bin_search(name, name2);
    e[2 * i][3] := bin_search(name, name1); 
  end;
  m := m * 2;
  readln(f_in, k);
  // Уже существующие рейсы добавляем с весом 0,
  // чтобы их добавить в первую очередь
  for i := 1 to k do
  begin
    readln(f_in, s);
    name1 := copy(s, 1, pos(' ', s) - 1);
    delete(s, 1, pos(' ', s));
    name2 := s;
    e[2 * i - 1 + m][1] := 0;
    e[2 * i - 1 + m][2] := bin_search(name, name1);
    e[2 * i - 1 + m][3] := bin_search(name, name2);
    e[2 * i + m][1] := 0;
    e[2 * i + m][2] := bin_search(name, name1);
    e[2 * i + m][3] := bin_search(name, name2);
  end;
  m := m + k * 2;
  close(f_in);
  // Сортировка ребер
  sort(1, m, e);
  // В начале каждая вершина находится в своей
  // компоненте связности
  for i := 1 to n do comp[i] := i;
  for i := 1 to n do
  begin
    setlength(sub_set[i], 1);
    sub_set[i][0] := i;
  end;
  ans := 0;
  count := 0;
  // Последовательно перебираем ребра, упорядоченные по весу
  for i := 1 to m do
  begin
    w := e[i][1];
    start := e[i][2];
    finish := e[i][3];
    comp_start := comp[start];
    comp_finish := comp[finish];
    // если comp_start = comp_finish, то ребро
    // лежит в одной компоненте связности
    // и его нужно пропустить
    if comp_start <> comp_finish then
    begin
      ans := ans + w;
      if w <> 0 then
        count := count + 1;
      if length(sub_set[comp_start]) < length(sub_set[comp_finish]) then
        swap(comp_start, comp_finish);
      // присоединяем к comp_start
      for j := 0 to length(sub_set[comp_finish]) - 1 do
      begin
        v := sub_set[comp_finish][j];
        comp[v] := comp_start;
      end;
      sub_set[comp_start] := sub_set[comp_start] + sub_set[comp_finish];
      // sub_set[comp_finish].clear();
    end;
  end;
  writeln(f_out, ans);
  close(f_out);
end.
